/*
  In an effort to help internalization, I think all messages to the user should
  be stored here; a language switch or something can specify which ones get
  compiled in.
  Randy Maas (1999/10/23)
*/
#ifndef __Dillo_Msgs_h
# define __Dillo_Msgs_h
# include <stdio.h>
# include <string.h>
# include <errno.h>

#ifndef PACKAGE
# define DILLO_NAME  "Armadillo: "
#else
# define DILLO_NAME  PACKAGE ": "
#endif
#define DILLO_ERROR "ERROR: "

#define DILLO_NO_HOSTNAME    "No host specified"
#define DILLO_NO_PROXYNAME   "Proxy server name is bogus"
#define DILLO_UNLINK_FAILED  "could not erase faulty %s: %s\n"
#define DILLO_MKDIR_FAILED   "error creating folder %s: %s\n"
#define DILLO_FORK_FAILED    "could not fork: %s\n"
#define DILLO_DUP2_FAILED    "error in dup2 call for %s: %s\n"
#define DILLO_EXEC_FAILED    "error in exec call for \"%s\": %s\n"
#define DILLO_PIPE_FAILED    "could not create a pipe: %s\n"
#define DILLO_BOOKMARK_FAILED "opening bookmark file %s: %s\n"
#define DILLO_PIPE_READ	      "reading from pipe: %s (%d)\n"
#define DILLO_DNS_SERVER      "creation of dns server failed - Exiting.\n"
#define DILLO_IOCTL_FAILED    "could not use IOCTL %s command: %s\n"
#define DILLO_TCSETATTR_FAILED "could not set original tty modes: %s\n"
#define DILLO_TIOCNOTTY_FAILED "could not disconnect controlling terminal: %s\n"
#define DILLO_TTY_FAILED       "unable to allocate pty/tty pair: %s\n"
#define DILLO_TCGETATTR_FAILED "can't get current tty state: %s\n"



/* GCCism: */
#define Err_cmdline(fmt,args...) fprintf(stderr, DILLO_NAME fmt, ## args)

#endif
