#ifndef __Platform_h
# define __Platform_h
# include "../config.h"

/* This define indicates that we want to use all of the API's */
# define _GNU_SOURCE 1
# define __USE_GNU   1

# if defined (HAVE_FCNTL_H) && HAVE_FCNTL_H
#  include <fcntl.h>
# endif
# if defined(HAVE_UNISTD_H) && HAVE_UNISTD_H
#  include <unistd.h>
# endif
# include <sys/param.h>
# ifdef HAVE_GLIB
#  include "glib.h"
# endif
# ifdef HAVE_STRING_H
#  include <string.h>
# else
#  ifdef HAVE_STRINGS_H
#   include <strings.h>
#  endif
# endif
# if !defined(HAVE_MEMCPY) && !defined(memcpy) && (defined(HAVE_BCOPY) || defined(bcopy))
#   define memcpy(dst,src,len) bcopy((src),(dst),(len))
# endif
# include <ctype.h>

# ifndef MAXPATHLEN
#  define MAXPATHLEN 1024
# endif

# ifdef __GNUC__
#  define FUNC       __const__
#  define INIT       section("startup")
#  define RSRC       section("rsrc")
#  define ATTR(x...) __attribute__((##x))
#  define EXTERN     extern __inline__
# else
#  define FUNC
#  define INIT
#  define ATTR(x)
#  define EXTERN  static _inline_
# endif

# ifndef isblank
#  define isblank(c) ((c)==' ' ||(c)=='\t')
# endif
# if !defined(HAVE_STRCHR) && !defined(strchr)
#  define strchr(s,c) index(s,c)
# endif


#ifndef Max
# define Max(a,b) ((a)>(b)?(a):(b))
#endif
#ifndef Min
# define Min(a,b) ((a)>(b)?(b):(a))
#endif

#ifndef TRUE
 #define TRUE  (1)
 #define FALSE (0)
#endif

#ifndef NULL
 #define NULL (0)
#endif

#ifdef __cplusplus
# define C_BEGIN extern "C" {
# define C_END   }
#else
# define C_BEGIN
# define C_END
#endif

C_BEGIN

EXTERN
const char* skipblank(const char* A)
{
  while(isblank(*A)) A++;
  return A;
}

EXTERN
const char* skippasteol(const char* Str)
{
   while (*Str && *Str != '\n') Str++;
   return *Str?Str+1:Str;
}

EXTERN
size_t strcnt(const char* Str, const char* Accept)
{
  size_t Cnt=0;
  while ((Str=strstr(Str,Accept))) {Cnt++; Str++;}
  return Cnt;
}

C_END
#endif
