/* $Id: help.c,v 1.3 2000/06/04 17:27:30 randym Exp $
 */

/* print help, keeping the prompt and stuff intact */

#include "platform.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
#include "psh.h"
#include "dillomsgs.h"

extern int errno;
extern int state, matchstate;
unsigned int helplev=MINLEVEL; /* the help level */

__AutoHelpEntry_t* helplist = NULL;
unsigned int numhints = 0;

/* this is a nasty hack */
static char *safestrncpy(char *dest, char*src, int n)
{
  size_t real_n;

  real_n = (n <= 0) ? 0 : n;
  return strncpy(dest, src, real_n);
}


/* read all help files */
void load_all_help(void)
{
  char fname[BUFSIZE];
  char *homedir;
  int homelen;

  if (__AutoHelp_load(GLOBALHELP, &helplist, &numhints))
    {
       if (errno==ENOMEM)
	 die("unable to allocate memory for new helptext", -1, errno);
    }

  if ((homedir = getenv("HOME")) != NULL) {
    safestrncpy (fname, homedir, BUFSIZE);
    homelen = strlen(fname);
    if (homelen > 0 && fname[homelen-1] != '/') { /* add a slash */
      fname[homelen++] = '/';
      fname[homelen] = '\0';
    }
    safestrncpy(fname+homelen, HOMEHELP, BUFSIZE-homelen);
    if (__AutoHelp_load(fname, &helplist, &numhints))
      {
	if (errno==ENOMEM)
	  die("unable to allocate memory for new helptext", -1, errno);
      }
  }
}

#if 0
/* generate an appropriate message - called by signal trap */
void print_help(const char* cmdbuf)
     /* Point into the prompt / command buffer
	to where the command actually starts
	(and the prompt ends); zero terminated*/
{
   char cmpbuf[BUFSIZE];
   __AutoHelpEntry_t* l;

   if (strncmp(UPLEVEL, l->Hint, strlen(UPLEVEL)) == 0) {
     /* special control hint - increase the help level */
     if (helplev < MAXLEVEL) {
       ++helplev;
       sprintf(cmpbuf, "Help level increased to %u\n", helplev);
       
     }
     else {
       sprintf(cmpbuf, "Help level cannot increase beyond %d\n",
	       MAXLEVEL);
     }
     message(cmpbuf);
   }
   else if (strncmp(DOWNLEVEL, l->Hint, strlen(DOWNLEVEL)) == 0) {
     /* special control hint - decrease the help level */
     if (helplev > MINLEVEL) {
       --helplev;
       sprintf(cmpbuf, "Help level decreased to %u\n", helplev);
     }
     else {
       sprintf(cmpbuf, "Help level cannot decrease below %d\n",
	       MINLEVEL);
     }
     message(cmpbuf);
   }
   else {
     message(l->Hint);
   }
}
#endif 
