/* $Id: sig.c,v 1.2 2000/06/04 17:27:30 randym Exp $
 */

/* signal setting code and handlers */

#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>
#include <stdio.h>
#include "psh.h"
#include "dillomsgs.h"

extern int run; /* indicates that the program should continue to run */
extern pid_t child_pid; /* PID of the child shell */

void child_handle(int sig)
{
  if (sig != SIGCHLD) return;
  run = 0;
  /* clean up the zombie if there is one */
  if (wait(NULL) == -1) {
    Err_cmdline("unable to reap child shell: %s\n", strerror(errno));
  }
}

/* handle, or don't handle, all appropriate signals */
void signals_mode(int mode)
{
  if (mode == LIVE) { /* activate signals */
    run = 1;
    if (signal(SIGCHLD, child_handle) == SIG_ERR) {
      die("unable to handle SIGCHLD", -1, 0);
    }
    return;
  }

  if (signal(SIGCHLD, SIG_DFL) == SIG_ERR) {
    die("unable to stop handling SIGCHLD", -1, 0);
  }
}
