/*
   Module to check that the IO is to a tty, and display a usage message
   otherwise
   Copright (c) 2000 Randall Maas (randym@acm.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "psh.h"

static void usage(void) ATTR(INIT);
static char msg[]="Usage:\tah-tty\n\tThis will display helpful messages at the"
" bottom of your terminal\n";
static void usage(void)
{
   write(2, msg, sizeof(msg));
}

/* @txh */
void check_stdio(void)
{
   /*
      Description
       This routine verifies that the stdin and stdout are both TTY channels.
       If not, a usage message is displayed, and @file{ah-tty} exits.

       If there is an error, we return.
   */

   if (isatty(0) && isatty(1)) return;
   usage();
   exit(-1);
}
